<?php

namespace PHPMaker2024\cidp24;

use Psr\Container\ContainerInterface;
use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Message\ResponseInterface as Response;
use PHPMaker2024\cidp24\Attributes\Delete;
use PHPMaker2024\cidp24\Attributes\Get;
use PHPMaker2024\cidp24\Attributes\Map;
use PHPMaker2024\cidp24\Attributes\Options;
use PHPMaker2024\cidp24\Attributes\Patch;
use PHPMaker2024\cidp24\Attributes\Post;
use PHPMaker2024\cidp24\Attributes\Put;

class DistrictSummaryViewController extends ControllerBase
{
    // list
    #[Map(["GET","POST","OPTIONS"], "/DistrictSummaryViewList", [PermissionMiddleware::class], "list.district_summary_view")]
    public function list(Request $request, Response $response, array $args): Response
    {
        return $this->runPage($request, $response, $args, "DistrictSummaryViewList");
    }

    // search
    #[Map(["GET","POST","OPTIONS"], "/DistrictSummaryViewSearch", [PermissionMiddleware::class], "search.district_summary_view")]
    public function search(Request $request, Response $response, array $args): Response
    {
        return $this->runPage($request, $response, $args, "DistrictSummaryViewSearch");
    }

    // query
    #[Map(["GET","POST","OPTIONS"], "/DistrictSummaryViewQuery", [PermissionMiddleware::class], "query.district_summary_view")]
    public function query(Request $request, Response $response, array $args): Response
    {
        return $this->runPage($request, $response, $args, "DistrictSummaryViewSearch", "DistrictSummaryViewQuery");
    }
}
