<?php

namespace PHPMaker2024\cidp24\Entity;

use DateTime;
use DateTimeImmutable;
use DateInterval;
use Doctrine\ORM\Mapping\Column;
use Doctrine\ORM\Mapping\Entity;
use Doctrine\ORM\Mapping\GeneratedValue;
use Doctrine\ORM\Mapping\Id;
use Doctrine\ORM\Mapping\Table;
use Doctrine\ORM\Mapping\SequenceGenerator;
use Doctrine\DBAL\Types\Types;
use PHPMaker2024\cidp24\AbstractEntity;
use PHPMaker2024\cidp24\AdvancedSecurity;
use PHPMaker2024\cidp24\UserProfile;
use function PHPMaker2024\cidp24\Config;
use function PHPMaker2024\cidp24\EntityManager;
use function PHPMaker2024\cidp24\RemoveXss;
use function PHPMaker2024\cidp24\HtmlDecode;
use function PHPMaker2024\cidp24\EncryptPassword;

/**
 * Entity class for "seed_variety" table
 */
#[Entity]
#[Table(name: "seed_variety")]
class SeedVariety extends AbstractEntity
{
    #[Id]
    #[Column(name: "SeedVariety", type: "string", unique: true)]
    private string $seedVariety;

    public function getSeedVariety(): string
    {
        return $this->seedVariety;
    }

    public function setSeedVariety(string $value): static
    {
        $this->seedVariety = $value;
        return $this;
    }
}
