<?php

namespace PHPMaker2024\cidp24;

// Page object
$FarmInspectionPreview = &$Page;
?>
<script>
ew.deepAssign(ew.vars, { tables: { farm_inspection: <?= JsonEncode($Page->toClientVar()) ?> } });
</script>
<script>
loadjs.ready("head", function () {
    // Write your table-specific client script here, no need to add script tags.
});
</script>
<?php $Page->showPageHeader(); ?>
<?php if ($Page->TotalRecords > 0) { ?>
<div class="card ew-grid <?= $Page->TableGridClass ?>"><!-- .card -->
<div class="card-header ew-grid-upper-panel ew-preview-upper-panel"><!-- .card-header -->
<?= $Page->Pager->render() ?>
<?php if ($Page->OtherOptions->visible()) { ?>
<div class="ew-preview-other-options">
<?php
    foreach ($Page->OtherOptions as $option) {
        $option->render("body");
    }
?>
</div>
<?php } ?>
</div><!-- /.card-header -->
<div class="card-body ew-preview-middle-panel ew-grid-middle-panel <?= $Page->TableContainerClass ?>" style="<?= $Page->TableContainerStyle ?>"><!-- .card-body -->
<table class="<?= $Page->TableClass ?>"><!-- .table -->
    <thead><!-- Table header -->
        <tr class="ew-table-header">
<?php
// Render list options
$Page->renderListOptions();

// Render list options (header, left)
$Page->ListOptions->render("header", "left");
?>
<?php if ($Page->ProvinceCode->Visible) { // ProvinceCode ?>
    <?php if (!$Page->ProvinceCode->Sortable || !$Page->sortUrl($Page->ProvinceCode)) { ?>
        <th class="<?= $Page->ProvinceCode->headerCellClass() ?>"><?= $Page->ProvinceCode->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->ProvinceCode->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->ProvinceCode->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->ProvinceCode->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->ProvinceCode->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->ProvinceCode->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->DistrictCode->Visible) { // DistrictCode ?>
    <?php if (!$Page->DistrictCode->Sortable || !$Page->sortUrl($Page->DistrictCode)) { ?>
        <th class="<?= $Page->DistrictCode->headerCellClass() ?>"><?= $Page->DistrictCode->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->DistrictCode->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->DistrictCode->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->DistrictCode->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->DistrictCode->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->DistrictCode->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->CampCode->Visible) { // CampCode ?>
    <?php if (!$Page->CampCode->Sortable || !$Page->sortUrl($Page->CampCode)) { ?>
        <th class="<?= $Page->CampCode->headerCellClass() ?>"><?= $Page->CampCode->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->CampCode->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->CampCode->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->CampCode->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->CampCode->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->CampCode->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->VillageCode->Visible) { // VillageCode ?>
    <?php if (!$Page->VillageCode->Sortable || !$Page->sortUrl($Page->VillageCode)) { ?>
        <th class="<?= $Page->VillageCode->headerCellClass() ?>"><?= $Page->VillageCode->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->VillageCode->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->VillageCode->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->VillageCode->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->VillageCode->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->VillageCode->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->NRC->Visible) { // NRC ?>
    <?php if (!$Page->NRC->Sortable || !$Page->sortUrl($Page->NRC)) { ?>
        <th class="<?= $Page->NRC->headerCellClass() ?>"><?= $Page->NRC->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->NRC->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->NRC->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->NRC->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->NRC->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->NRC->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->FarmerNo->Visible) { // FarmerNo ?>
    <?php if (!$Page->FarmerNo->Sortable || !$Page->sortUrl($Page->FarmerNo)) { ?>
        <th class="<?= $Page->FarmerNo->headerCellClass() ?>"><?= $Page->FarmerNo->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->FarmerNo->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->FarmerNo->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->FarmerNo->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->FarmerNo->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->FarmerNo->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->FarmNo->Visible) { // FarmNo ?>
    <?php if (!$Page->FarmNo->Sortable || !$Page->sortUrl($Page->FarmNo)) { ?>
        <th class="<?= $Page->FarmNo->headerCellClass() ?>"><?= $Page->FarmNo->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->FarmNo->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->FarmNo->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->FarmNo->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->FarmNo->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->FarmNo->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->InspectionTransNo->Visible) { // InspectionTransNo ?>
    <?php if (!$Page->InspectionTransNo->Sortable || !$Page->sortUrl($Page->InspectionTransNo)) { ?>
        <th class="<?= $Page->InspectionTransNo->headerCellClass() ?>"><?= $Page->InspectionTransNo->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->InspectionTransNo->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->InspectionTransNo->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->InspectionTransNo->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->InspectionTransNo->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->InspectionTransNo->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->PlantsDead->Visible) { // PlantsDead ?>
    <?php if (!$Page->PlantsDead->Sortable || !$Page->sortUrl($Page->PlantsDead)) { ?>
        <th class="<?= $Page->PlantsDead->headerCellClass() ?>"><?= $Page->PlantsDead->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->PlantsDead->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->PlantsDead->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->PlantsDead->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->PlantsDead->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->PlantsDead->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->PlantsVerifiedNo->Visible) { // PlantsVerifiedNo ?>
    <?php if (!$Page->PlantsVerifiedNo->Sortable || !$Page->sortUrl($Page->PlantsVerifiedNo)) { ?>
        <th class="<?= $Page->PlantsVerifiedNo->headerCellClass() ?>"><?= $Page->PlantsVerifiedNo->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->PlantsVerifiedNo->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->PlantsVerifiedNo->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->PlantsVerifiedNo->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->PlantsVerifiedNo->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->PlantsVerifiedNo->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->PlantsReplaced->Visible) { // PlantsReplaced ?>
    <?php if (!$Page->PlantsReplaced->Sortable || !$Page->sortUrl($Page->PlantsReplaced)) { ?>
        <th class="<?= $Page->PlantsReplaced->headerCellClass() ?>"><?= $Page->PlantsReplaced->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->PlantsReplaced->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->PlantsReplaced->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->PlantsReplaced->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->PlantsReplaced->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->PlantsReplaced->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->FungicidesReceived->Visible) { // FungicidesReceived ?>
    <?php if (!$Page->FungicidesReceived->Sortable || !$Page->sortUrl($Page->FungicidesReceived)) { ?>
        <th class="<?= $Page->FungicidesReceived->headerCellClass() ?>"><?= $Page->FungicidesReceived->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->FungicidesReceived->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->FungicidesReceived->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->FungicidesReceived->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->FungicidesReceived->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->FungicidesReceived->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->PescticidesReceived->Visible) { // PescticidesReceived ?>
    <?php if (!$Page->PescticidesReceived->Sortable || !$Page->sortUrl($Page->PescticidesReceived)) { ?>
        <th class="<?= $Page->PescticidesReceived->headerCellClass() ?>"><?= $Page->PescticidesReceived->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->PescticidesReceived->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->PescticidesReceived->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->PescticidesReceived->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->PescticidesReceived->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->PescticidesReceived->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->DiseasePresence->Visible) { // DiseasePresence ?>
    <?php if (!$Page->DiseasePresence->Sortable || !$Page->sortUrl($Page->DiseasePresence)) { ?>
        <th class="<?= $Page->DiseasePresence->headerCellClass() ?>"><?= $Page->DiseasePresence->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->DiseasePresence->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->DiseasePresence->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->DiseasePresence->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->DiseasePresence->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->DiseasePresence->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->AvailableLand->Visible) { // AvailableLand ?>
    <?php if (!$Page->AvailableLand->Sortable || !$Page->sortUrl($Page->AvailableLand)) { ?>
        <th class="<?= $Page->AvailableLand->headerCellClass() ?>"><?= $Page->AvailableLand->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->AvailableLand->headerCellClass() ?>"><div role="button" data-table="farm_inspection" data-sort="<?= HtmlEncode($Page->AvailableLand->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->AvailableLand->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->AvailableLand->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->AvailableLand->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php
// Render list options (header, right)
$Page->ListOptions->render("header", "right");
?>
        </tr>
    </thead>
    <tbody><!-- Table body -->
<?php
$Page->RecordCount = 0;
$Page->RowCount = 0;
while ($Page->fetch()) {
    // Init row class and style
    $Page->RecordCount++;
    $Page->RowCount++;
    $Page->CssStyle = "";
    $Page->loadListRowValues($Page->CurrentRow);

    // Render row
    $Page->RowType = RowType::PREVIEW; // Preview record
    $Page->resetAttributes();
    $Page->renderListRow();

    // Set up row attributes
    $Page->RowAttrs->merge([
        "data-rowindex" => $Page->RowCount,
        "class" => ($Page->RowCount % 2 != 1) ? "ew-table-alt-row" : "",

        // Add row attributes for expandable row
        "data-widget" => "expandable-table",
        "aria-expanded" => "false",
    ]);

    // Render list options
    $Page->renderListOptions();
?>
    <tr <?= $Page->rowAttributes() ?>>
<?php
// Render list options (body, left)
$Page->ListOptions->render("body", "left", $Page->RowCount);
?>
<?php if ($Page->ProvinceCode->Visible) { // ProvinceCode ?>
        <!-- ProvinceCode -->
        <td<?= $Page->ProvinceCode->cellAttributes() ?>>
<span<?= $Page->ProvinceCode->viewAttributes() ?>>
<?= $Page->ProvinceCode->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->DistrictCode->Visible) { // DistrictCode ?>
        <!-- DistrictCode -->
        <td<?= $Page->DistrictCode->cellAttributes() ?>>
<span<?= $Page->DistrictCode->viewAttributes() ?>>
<?= $Page->DistrictCode->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->CampCode->Visible) { // CampCode ?>
        <!-- CampCode -->
        <td<?= $Page->CampCode->cellAttributes() ?>>
<span<?= $Page->CampCode->viewAttributes() ?>>
<?= $Page->CampCode->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->VillageCode->Visible) { // VillageCode ?>
        <!-- VillageCode -->
        <td<?= $Page->VillageCode->cellAttributes() ?>>
<span<?= $Page->VillageCode->viewAttributes() ?>>
<?= $Page->VillageCode->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->NRC->Visible) { // NRC ?>
        <!-- NRC -->
        <td<?= $Page->NRC->cellAttributes() ?>>
<span<?= $Page->NRC->viewAttributes() ?>>
<?= $Page->NRC->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->FarmerNo->Visible) { // FarmerNo ?>
        <!-- FarmerNo -->
        <td<?= $Page->FarmerNo->cellAttributes() ?>>
<span<?= $Page->FarmerNo->viewAttributes() ?>>
<?= $Page->FarmerNo->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->FarmNo->Visible) { // FarmNo ?>
        <!-- FarmNo -->
        <td<?= $Page->FarmNo->cellAttributes() ?>>
<span<?= $Page->FarmNo->viewAttributes() ?>>
<?= $Page->FarmNo->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->InspectionTransNo->Visible) { // InspectionTransNo ?>
        <!-- InspectionTransNo -->
        <td<?= $Page->InspectionTransNo->cellAttributes() ?>>
<span<?= $Page->InspectionTransNo->viewAttributes() ?>>
<?= $Page->InspectionTransNo->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->PlantsDead->Visible) { // PlantsDead ?>
        <!-- PlantsDead -->
        <td<?= $Page->PlantsDead->cellAttributes() ?>>
<span<?= $Page->PlantsDead->viewAttributes() ?>>
<?= $Page->PlantsDead->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->PlantsVerifiedNo->Visible) { // PlantsVerifiedNo ?>
        <!-- PlantsVerifiedNo -->
        <td<?= $Page->PlantsVerifiedNo->cellAttributes() ?>>
<span<?= $Page->PlantsVerifiedNo->viewAttributes() ?>>
<?= $Page->PlantsVerifiedNo->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->PlantsReplaced->Visible) { // PlantsReplaced ?>
        <!-- PlantsReplaced -->
        <td<?= $Page->PlantsReplaced->cellAttributes() ?>>
<span<?= $Page->PlantsReplaced->viewAttributes() ?>>
<?= $Page->PlantsReplaced->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->FungicidesReceived->Visible) { // FungicidesReceived ?>
        <!-- FungicidesReceived -->
        <td<?= $Page->FungicidesReceived->cellAttributes() ?>>
<span<?= $Page->FungicidesReceived->viewAttributes() ?>>
<?= $Page->FungicidesReceived->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->PescticidesReceived->Visible) { // PescticidesReceived ?>
        <!-- PescticidesReceived -->
        <td<?= $Page->PescticidesReceived->cellAttributes() ?>>
<span<?= $Page->PescticidesReceived->viewAttributes() ?>>
<?= $Page->PescticidesReceived->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->DiseasePresence->Visible) { // DiseasePresence ?>
        <!-- DiseasePresence -->
        <td<?= $Page->DiseasePresence->cellAttributes() ?>>
<span<?= $Page->DiseasePresence->viewAttributes() ?>>
<?= $Page->DiseasePresence->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->AvailableLand->Visible) { // AvailableLand ?>
        <!-- AvailableLand -->
        <td<?= $Page->AvailableLand->cellAttributes() ?>>
<span<?= $Page->AvailableLand->viewAttributes() ?>>
<?= $Page->AvailableLand->getViewValue() ?></span>
</td>
<?php } ?>
<?php
// Render list options (body, right)
$Page->ListOptions->render("body", "right", $Page->RowCount);
?>
    </tr>
<?php
} // while
?>
    </tbody>
</table><!-- /.table -->
</div><!-- /.card-body -->
<div class="card-footer ew-grid-lower-panel ew-preview-lower-panel"><!-- .card-footer -->
<?= $Page->Pager->render() ?>
<?php if ($Page->OtherOptions->visible()) { ?>
<div class="ew-preview-other-options">
<?php
    foreach ($Page->OtherOptions as $option) {
        $option->render("body");
    }
?>
</div>
<?php } ?>
</div><!-- /.card-footer -->
</div><!-- /.card -->
<?php } else { // No record ?>
<div class="card border-0"><!-- .card -->
<div class="ew-detail-count"><?= $Language->phrase("NoRecord") ?></div>
<?php if ($Page->OtherOptions->visible()) { ?>
<div class="ew-preview-other-options">
<?php
    foreach ($Page->OtherOptions as $option) {
        $option->render("body");
    }
?>
</div>
<?php } ?>
</div><!-- /.card -->
<?php } ?>
<?php
foreach ($Page->DetailCounts as $detailTblVar => $detailCount) {
?>
<div class="ew-detail-count d-none" data-table="<?= $detailTblVar ?>" data-count="<?= $detailCount ?>"><?= FormatInteger($detailCount) ?></div>
<?php
}
?>
<?php
$Page->showPageFooter();
echo GetDebugMessage();
?>
<?php
$Page->Recordset?->free();
?>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
