<?php

namespace PHPMaker2024\cidp24;

// Page object
$FarmerOrganisationAdd = &$Page;
?>
<script>
var currentTable = <?= JsonEncode($Page->toClientVar()) ?>;
ew.deepAssign(ew.vars, { tables: { farmer_organisation: currentTable } });
var currentPageID = ew.PAGE_ID = "add";
var currentForm;
var ffarmer_organisationadd;
loadjs.ready(["wrapper", "head"], function () {
    let $ = jQuery;
    let fields = currentTable.fields;

    // Form object
    let form = new ew.FormBuilder()
        .setId("ffarmer_organisationadd")
        .setPageId("add")

        // Add fields
        .setFields([
            ["ProvinceCode", [fields.ProvinceCode.visible && fields.ProvinceCode.required ? ew.Validators.required(fields.ProvinceCode.caption) : null], fields.ProvinceCode.isInvalid],
            ["DistrictCode", [fields.DistrictCode.visible && fields.DistrictCode.required ? ew.Validators.required(fields.DistrictCode.caption) : null], fields.DistrictCode.isInvalid],
            ["OrgCode", [fields.OrgCode.visible && fields.OrgCode.required ? ew.Validators.required(fields.OrgCode.caption) : null, ew.Validators.integer], fields.OrgCode.isInvalid],
            ["FarmerOrganisation", [fields.FarmerOrganisation.visible && fields.FarmerOrganisation.required ? ew.Validators.required(fields.FarmerOrganisation.caption) : null], fields.FarmerOrganisation.isInvalid],
            ["FOType", [fields.FOType.visible && fields.FOType.required ? ew.Validators.required(fields.FOType.caption) : null], fields.FOType.isInvalid],
            ["PhysicalAddress", [fields.PhysicalAddress.visible && fields.PhysicalAddress.required ? ew.Validators.required(fields.PhysicalAddress.caption) : null], fields.PhysicalAddress.isInvalid],
            ["PostalAddress", [fields.PostalAddress.visible && fields.PostalAddress.required ? ew.Validators.required(fields.PostalAddress.caption) : null], fields.PostalAddress.isInvalid],
            ["Phone", [fields.Phone.visible && fields.Phone.required ? ew.Validators.required(fields.Phone.caption) : null], fields.Phone.isInvalid],
            ["_Email", [fields._Email.visible && fields._Email.required ? ew.Validators.required(fields._Email.caption) : null, ew.Validators.email], fields._Email.isInvalid]
        ])

        // Form_CustomValidate
        .setCustomValidate(
            function (fobj) { // DO NOT CHANGE THIS LINE! (except for adding "async" keyword)!
                    // Your custom validation code here, return false if invalid.
                    return true;
                }
        )

        // Use JavaScript validation or not
        .setValidateRequired(ew.CLIENT_VALIDATE)

        // Dynamic selection lists
        .setLists({
            "ProvinceCode": <?= $Page->ProvinceCode->toClientList($Page) ?>,
            "DistrictCode": <?= $Page->DistrictCode->toClientList($Page) ?>,
            "FOType": <?= $Page->FOType->toClientList($Page) ?>,
        })
        .build();
    window[form.id] = form;
    currentForm = form;
    loadjs.done(form.id);
});
</script>
<script>
loadjs.ready("head", function () {
    // Write your table-specific client script here, no need to add script tags.
});
</script>
<?php $Page->showPageHeader(); ?>
<?php
$Page->showMessage();
?>
<form name="ffarmer_organisationadd" id="ffarmer_organisationadd" class="<?= $Page->FormClassName ?>" action="<?= CurrentPageUrl(false) ?>" method="post" autocomplete="off">
<?php if (Config("CHECK_TOKEN")) { ?>
<input type="hidden" name="<?= $TokenNameKey ?>" value="<?= $TokenName ?>"><!-- CSRF token name -->
<input type="hidden" name="<?= $TokenValueKey ?>" value="<?= $TokenValue ?>"><!-- CSRF token value -->
<?php } ?>
<input type="hidden" name="t" value="farmer_organisation">
<input type="hidden" name="action" id="action" value="insert">
<input type="hidden" name="modal" value="<?= (int)$Page->IsModal ?>">
<?php if (IsJsonResponse()) { ?>
<input type="hidden" name="json" value="1">
<?php } ?>
<input type="hidden" name="<?= $Page->OldKeyName ?>" value="<?= $Page->OldKey ?>">
<?php if ($Page->getCurrentMasterTable() == "district") { ?>
<input type="hidden" name="<?= Config("TABLE_SHOW_MASTER") ?>" value="district">
<input type="hidden" name="fk_ProvinceCode" value="<?= HtmlEncode($Page->ProvinceCode->getSessionValue()) ?>">
<input type="hidden" name="fk_DistrictCode" value="<?= HtmlEncode($Page->DistrictCode->getSessionValue()) ?>">
<?php } ?>
<div class="ew-add-div"><!-- page* -->
<?php if ($Page->ProvinceCode->Visible) { // ProvinceCode ?>
    <div id="r_ProvinceCode"<?= $Page->ProvinceCode->rowAttributes() ?>>
        <label id="elh_farmer_organisation_ProvinceCode" for="x_ProvinceCode" class="<?= $Page->LeftColumnClass ?>"><?= $Page->ProvinceCode->caption() ?><?= $Page->ProvinceCode->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->ProvinceCode->cellAttributes() ?>>
<?php if ($Page->ProvinceCode->getSessionValue() != "") { ?>
<span<?= $Page->ProvinceCode->viewAttributes() ?>>
<span class="form-control-plaintext"><?= $Page->ProvinceCode->getDisplayValue($Page->ProvinceCode->ViewValue) ?></span></span>
<input type="hidden" id="x_ProvinceCode" name="x_ProvinceCode" value="<?= HtmlEncode($Page->ProvinceCode->CurrentValue) ?>" data-hidden="1">
<?php } else { ?>
<span id="el_farmer_organisation_ProvinceCode">
    <select
        id="x_ProvinceCode"
        name="x_ProvinceCode"
        class="form-select ew-select<?= $Page->ProvinceCode->isInvalidClass() ?>"
        <?php if (!$Page->ProvinceCode->IsNativeSelect) { ?>
        data-select2-id="ffarmer_organisationadd_x_ProvinceCode"
        <?php } ?>
        data-table="farmer_organisation"
        data-field="x_ProvinceCode"
        data-value-separator="<?= $Page->ProvinceCode->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->ProvinceCode->getPlaceHolder()) ?>"
        data-ew-action="update-options"
        <?= $Page->ProvinceCode->editAttributes() ?>>
        <?= $Page->ProvinceCode->selectOptionListHtml("x_ProvinceCode") ?>
    </select>
    <?= $Page->ProvinceCode->getCustomMessage() ?>
    <div class="invalid-feedback"><?= $Page->ProvinceCode->getErrorMessage() ?></div>
<?= $Page->ProvinceCode->Lookup->getParamTag($Page, "p_x_ProvinceCode") ?>
<?php if (!$Page->ProvinceCode->IsNativeSelect) { ?>
<script>
loadjs.ready("ffarmer_organisationadd", function() {
    var options = { name: "x_ProvinceCode", selectId: "ffarmer_organisationadd_x_ProvinceCode" },
        el = document.querySelector("select[data-select2-id='" + options.selectId + "']");
    if (!el)
        return;
    options.closeOnSelect = !options.multiple;
    options.dropdownParent = el.closest("#ew-modal-dialog, #ew-add-opt-dialog");
    if (ffarmer_organisationadd.lists.ProvinceCode?.lookupOptions.length) {
        options.data = { id: "x_ProvinceCode", form: "ffarmer_organisationadd" };
    } else {
        options.ajax = { id: "x_ProvinceCode", form: "ffarmer_organisationadd", limit: ew.LOOKUP_PAGE_SIZE };
    }
    options.minimumResultsForSearch = Infinity;
    options = Object.assign({}, ew.selectOptions, options, ew.vars.tables.farmer_organisation.fields.ProvinceCode.selectOptions);
    ew.createSelect(options);
});
</script>
<?php } ?>
</span>
<?php } ?>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->DistrictCode->Visible) { // DistrictCode ?>
    <div id="r_DistrictCode"<?= $Page->DistrictCode->rowAttributes() ?>>
        <label id="elh_farmer_organisation_DistrictCode" for="x_DistrictCode" class="<?= $Page->LeftColumnClass ?>"><?= $Page->DistrictCode->caption() ?><?= $Page->DistrictCode->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->DistrictCode->cellAttributes() ?>>
<?php if ($Page->DistrictCode->getSessionValue() != "") { ?>
<span<?= $Page->DistrictCode->viewAttributes() ?>>
<span class="form-control-plaintext"><?= $Page->DistrictCode->getDisplayValue($Page->DistrictCode->ViewValue) ?></span></span>
<input type="hidden" id="x_DistrictCode" name="x_DistrictCode" value="<?= HtmlEncode($Page->DistrictCode->CurrentValue) ?>" data-hidden="1">
<?php } else { ?>
<span id="el_farmer_organisation_DistrictCode">
    <select
        id="x_DistrictCode"
        name="x_DistrictCode"
        class="form-select ew-select<?= $Page->DistrictCode->isInvalidClass() ?>"
        <?php if (!$Page->DistrictCode->IsNativeSelect) { ?>
        data-select2-id="ffarmer_organisationadd_x_DistrictCode"
        <?php } ?>
        data-table="farmer_organisation"
        data-field="x_DistrictCode"
        data-value-separator="<?= $Page->DistrictCode->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->DistrictCode->getPlaceHolder()) ?>"
        <?= $Page->DistrictCode->editAttributes() ?>>
        <?= $Page->DistrictCode->selectOptionListHtml("x_DistrictCode") ?>
    </select>
    <?= $Page->DistrictCode->getCustomMessage() ?>
    <div class="invalid-feedback"><?= $Page->DistrictCode->getErrorMessage() ?></div>
<?= $Page->DistrictCode->Lookup->getParamTag($Page, "p_x_DistrictCode") ?>
<?php if (!$Page->DistrictCode->IsNativeSelect) { ?>
<script>
loadjs.ready("ffarmer_organisationadd", function() {
    var options = { name: "x_DistrictCode", selectId: "ffarmer_organisationadd_x_DistrictCode" },
        el = document.querySelector("select[data-select2-id='" + options.selectId + "']");
    if (!el)
        return;
    options.closeOnSelect = !options.multiple;
    options.dropdownParent = el.closest("#ew-modal-dialog, #ew-add-opt-dialog");
    if (ffarmer_organisationadd.lists.DistrictCode?.lookupOptions.length) {
        options.data = { id: "x_DistrictCode", form: "ffarmer_organisationadd" };
    } else {
        options.ajax = { id: "x_DistrictCode", form: "ffarmer_organisationadd", limit: ew.LOOKUP_PAGE_SIZE };
    }
    options.minimumResultsForSearch = Infinity;
    options = Object.assign({}, ew.selectOptions, options, ew.vars.tables.farmer_organisation.fields.DistrictCode.selectOptions);
    ew.createSelect(options);
});
</script>
<?php } ?>
</span>
<?php } ?>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->OrgCode->Visible) { // OrgCode ?>
    <div id="r_OrgCode"<?= $Page->OrgCode->rowAttributes() ?>>
        <label id="elh_farmer_organisation_OrgCode" for="x_OrgCode" class="<?= $Page->LeftColumnClass ?>"><?= $Page->OrgCode->caption() ?><?= $Page->OrgCode->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->OrgCode->cellAttributes() ?>>
<span id="el_farmer_organisation_OrgCode">
<input type="<?= $Page->OrgCode->getInputTextType() ?>" name="x_OrgCode" id="x_OrgCode" data-table="farmer_organisation" data-field="x_OrgCode" value="<?= $Page->OrgCode->EditValue ?>" placeholder="<?= HtmlEncode($Page->OrgCode->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->OrgCode->formatPattern()) ?>"<?= $Page->OrgCode->editAttributes() ?> aria-describedby="x_OrgCode_help">
<?= $Page->OrgCode->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->OrgCode->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->FarmerOrganisation->Visible) { // FarmerOrganisation ?>
    <div id="r_FarmerOrganisation"<?= $Page->FarmerOrganisation->rowAttributes() ?>>
        <label id="elh_farmer_organisation_FarmerOrganisation" for="x_FarmerOrganisation" class="<?= $Page->LeftColumnClass ?>"><?= $Page->FarmerOrganisation->caption() ?><?= $Page->FarmerOrganisation->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->FarmerOrganisation->cellAttributes() ?>>
<span id="el_farmer_organisation_FarmerOrganisation">
<input type="<?= $Page->FarmerOrganisation->getInputTextType() ?>" name="x_FarmerOrganisation" id="x_FarmerOrganisation" data-table="farmer_organisation" data-field="x_FarmerOrganisation" value="<?= $Page->FarmerOrganisation->EditValue ?>" size="50" maxlength="255" placeholder="<?= HtmlEncode($Page->FarmerOrganisation->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->FarmerOrganisation->formatPattern()) ?>"<?= $Page->FarmerOrganisation->editAttributes() ?> aria-describedby="x_FarmerOrganisation_help">
<?= $Page->FarmerOrganisation->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->FarmerOrganisation->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->FOType->Visible) { // FOType ?>
    <div id="r_FOType"<?= $Page->FOType->rowAttributes() ?>>
        <label id="elh_farmer_organisation_FOType" for="x_FOType" class="<?= $Page->LeftColumnClass ?>"><?= $Page->FOType->caption() ?><?= $Page->FOType->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->FOType->cellAttributes() ?>>
<span id="el_farmer_organisation_FOType">
    <select
        id="x_FOType"
        name="x_FOType"
        class="form-select ew-select<?= $Page->FOType->isInvalidClass() ?>"
        <?php if (!$Page->FOType->IsNativeSelect) { ?>
        data-select2-id="ffarmer_organisationadd_x_FOType"
        <?php } ?>
        data-table="farmer_organisation"
        data-field="x_FOType"
        data-value-separator="<?= $Page->FOType->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->FOType->getPlaceHolder()) ?>"
        <?= $Page->FOType->editAttributes() ?>>
        <?= $Page->FOType->selectOptionListHtml("x_FOType") ?>
    </select>
    <?= $Page->FOType->getCustomMessage() ?>
    <div class="invalid-feedback"><?= $Page->FOType->getErrorMessage() ?></div>
<?= $Page->FOType->Lookup->getParamTag($Page, "p_x_FOType") ?>
<?php if (!$Page->FOType->IsNativeSelect) { ?>
<script>
loadjs.ready("ffarmer_organisationadd", function() {
    var options = { name: "x_FOType", selectId: "ffarmer_organisationadd_x_FOType" },
        el = document.querySelector("select[data-select2-id='" + options.selectId + "']");
    if (!el)
        return;
    options.closeOnSelect = !options.multiple;
    options.dropdownParent = el.closest("#ew-modal-dialog, #ew-add-opt-dialog");
    if (ffarmer_organisationadd.lists.FOType?.lookupOptions.length) {
        options.data = { id: "x_FOType", form: "ffarmer_organisationadd" };
    } else {
        options.ajax = { id: "x_FOType", form: "ffarmer_organisationadd", limit: ew.LOOKUP_PAGE_SIZE };
    }
    options.minimumResultsForSearch = Infinity;
    options = Object.assign({}, ew.selectOptions, options, ew.vars.tables.farmer_organisation.fields.FOType.selectOptions);
    ew.createSelect(options);
});
</script>
<?php } ?>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->PhysicalAddress->Visible) { // PhysicalAddress ?>
    <div id="r_PhysicalAddress"<?= $Page->PhysicalAddress->rowAttributes() ?>>
        <label id="elh_farmer_organisation_PhysicalAddress" for="x_PhysicalAddress" class="<?= $Page->LeftColumnClass ?>"><?= $Page->PhysicalAddress->caption() ?><?= $Page->PhysicalAddress->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->PhysicalAddress->cellAttributes() ?>>
<span id="el_farmer_organisation_PhysicalAddress">
<input type="<?= $Page->PhysicalAddress->getInputTextType() ?>" name="x_PhysicalAddress" id="x_PhysicalAddress" data-table="farmer_organisation" data-field="x_PhysicalAddress" value="<?= $Page->PhysicalAddress->EditValue ?>" size="50" maxlength="255" placeholder="<?= HtmlEncode($Page->PhysicalAddress->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->PhysicalAddress->formatPattern()) ?>"<?= $Page->PhysicalAddress->editAttributes() ?> aria-describedby="x_PhysicalAddress_help">
<?= $Page->PhysicalAddress->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->PhysicalAddress->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->PostalAddress->Visible) { // PostalAddress ?>
    <div id="r_PostalAddress"<?= $Page->PostalAddress->rowAttributes() ?>>
        <label id="elh_farmer_organisation_PostalAddress" for="x_PostalAddress" class="<?= $Page->LeftColumnClass ?>"><?= $Page->PostalAddress->caption() ?><?= $Page->PostalAddress->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->PostalAddress->cellAttributes() ?>>
<span id="el_farmer_organisation_PostalAddress">
<input type="<?= $Page->PostalAddress->getInputTextType() ?>" name="x_PostalAddress" id="x_PostalAddress" data-table="farmer_organisation" data-field="x_PostalAddress" value="<?= $Page->PostalAddress->EditValue ?>" size="50" maxlength="255" placeholder="<?= HtmlEncode($Page->PostalAddress->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->PostalAddress->formatPattern()) ?>"<?= $Page->PostalAddress->editAttributes() ?> aria-describedby="x_PostalAddress_help">
<?= $Page->PostalAddress->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->PostalAddress->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->Phone->Visible) { // Phone ?>
    <div id="r_Phone"<?= $Page->Phone->rowAttributes() ?>>
        <label id="elh_farmer_organisation_Phone" for="x_Phone" class="<?= $Page->LeftColumnClass ?>"><?= $Page->Phone->caption() ?><?= $Page->Phone->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->Phone->cellAttributes() ?>>
<span id="el_farmer_organisation_Phone">
<input type="<?= $Page->Phone->getInputTextType() ?>" name="x_Phone" id="x_Phone" data-table="farmer_organisation" data-field="x_Phone" value="<?= $Page->Phone->EditValue ?>" size="30" maxlength="255" placeholder="<?= HtmlEncode($Page->Phone->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->Phone->formatPattern()) ?>"<?= $Page->Phone->editAttributes() ?> aria-describedby="x_Phone_help">
<?= $Page->Phone->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->Phone->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->_Email->Visible) { // Email ?>
    <div id="r__Email"<?= $Page->_Email->rowAttributes() ?>>
        <label id="elh_farmer_organisation__Email" for="x__Email" class="<?= $Page->LeftColumnClass ?>"><?= $Page->_Email->caption() ?><?= $Page->_Email->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->_Email->cellAttributes() ?>>
<span id="el_farmer_organisation__Email">
<input type="<?= $Page->_Email->getInputTextType() ?>" name="x__Email" id="x__Email" data-table="farmer_organisation" data-field="x__Email" value="<?= $Page->_Email->EditValue ?>" size="30" maxlength="255" placeholder="<?= HtmlEncode($Page->_Email->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->_Email->formatPattern()) ?>"<?= $Page->_Email->editAttributes() ?> aria-describedby="x__Email_help">
<?= $Page->_Email->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->_Email->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
</div><!-- /page* -->
<?= $Page->IsModal ? '<template class="ew-modal-buttons">' : '<div class="row ew-buttons">' ?><!-- buttons .row -->
    <div class="<?= $Page->OffsetColumnClass ?>"><!-- buttons offset -->
<button class="btn btn-primary ew-btn" name="btn-action" id="btn-action" type="submit" form="ffarmer_organisationadd"><?= $Language->phrase("AddBtn") ?></button>
<?php if (IsJsonResponse()) { ?>
<button class="btn btn-default ew-btn" name="btn-cancel" id="btn-cancel" type="button" data-bs-dismiss="modal"><?= $Language->phrase("CancelBtn") ?></button>
<?php } else { ?>
<button class="btn btn-default ew-btn" name="btn-cancel" id="btn-cancel" type="button" form="ffarmer_organisationadd" data-href="<?= HtmlEncode(GetUrl($Page->getReturnUrl())) ?>"><?= $Language->phrase("CancelBtn") ?></button>
<?php } ?>
    </div><!-- /buttons offset -->
<?= $Page->IsModal ? "</template>" : "</div>" ?><!-- /buttons .row -->
</form>
<?php
$Page->showPageFooter();
echo GetDebugMessage();
?>
<script>
// Field event handlers
loadjs.ready("head", function() {
    ew.addEventHandlers("farmer_organisation");
});
</script>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
