<?php

namespace PHPMaker2024\cidp24;

// Page object
$FarmerOrganisationPreview = &$Page;
?>
<script>
ew.deepAssign(ew.vars, { tables: { farmer_organisation: <?= JsonEncode($Page->toClientVar()) ?> } });
</script>
<script>
loadjs.ready("head", function () {
    // Write your table-specific client script here, no need to add script tags.
});
</script>
<?php $Page->showPageHeader(); ?>
<?php if ($Page->TotalRecords > 0) { ?>
<div class="card ew-grid <?= $Page->TableGridClass ?>"><!-- .card -->
<div class="card-header ew-grid-upper-panel ew-preview-upper-panel"><!-- .card-header -->
<?= $Page->Pager->render() ?>
<?php if ($Page->OtherOptions->visible()) { ?>
<div class="ew-preview-other-options">
<?php
    foreach ($Page->OtherOptions as $option) {
        $option->render("body");
    }
?>
</div>
<?php } ?>
</div><!-- /.card-header -->
<div class="card-body ew-preview-middle-panel ew-grid-middle-panel <?= $Page->TableContainerClass ?>" style="<?= $Page->TableContainerStyle ?>"><!-- .card-body -->
<table class="<?= $Page->TableClass ?>"><!-- .table -->
    <thead><!-- Table header -->
        <tr class="ew-table-header">
<?php
// Render list options
$Page->renderListOptions();

// Render list options (header, left)
$Page->ListOptions->render("header", "left");
?>
<?php if ($Page->ProvinceCode->Visible) { // ProvinceCode ?>
    <?php if (!$Page->ProvinceCode->Sortable || !$Page->sortUrl($Page->ProvinceCode)) { ?>
        <th class="<?= $Page->ProvinceCode->headerCellClass() ?>"><?= $Page->ProvinceCode->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->ProvinceCode->headerCellClass() ?>"><div role="button" data-table="farmer_organisation" data-sort="<?= HtmlEncode($Page->ProvinceCode->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->ProvinceCode->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->ProvinceCode->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->ProvinceCode->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->DistrictCode->Visible) { // DistrictCode ?>
    <?php if (!$Page->DistrictCode->Sortable || !$Page->sortUrl($Page->DistrictCode)) { ?>
        <th class="<?= $Page->DistrictCode->headerCellClass() ?>"><?= $Page->DistrictCode->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->DistrictCode->headerCellClass() ?>"><div role="button" data-table="farmer_organisation" data-sort="<?= HtmlEncode($Page->DistrictCode->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->DistrictCode->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->DistrictCode->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->DistrictCode->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->OrgCode->Visible) { // OrgCode ?>
    <?php if (!$Page->OrgCode->Sortable || !$Page->sortUrl($Page->OrgCode)) { ?>
        <th class="<?= $Page->OrgCode->headerCellClass() ?>"><?= $Page->OrgCode->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->OrgCode->headerCellClass() ?>"><div role="button" data-table="farmer_organisation" data-sort="<?= HtmlEncode($Page->OrgCode->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->OrgCode->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->OrgCode->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->OrgCode->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->FarmerOrganisation->Visible) { // FarmerOrganisation ?>
    <?php if (!$Page->FarmerOrganisation->Sortable || !$Page->sortUrl($Page->FarmerOrganisation)) { ?>
        <th class="<?= $Page->FarmerOrganisation->headerCellClass() ?>"><?= $Page->FarmerOrganisation->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->FarmerOrganisation->headerCellClass() ?>"><div role="button" data-table="farmer_organisation" data-sort="<?= HtmlEncode($Page->FarmerOrganisation->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->FarmerOrganisation->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->FarmerOrganisation->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->FarmerOrganisation->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->FOType->Visible) { // FOType ?>
    <?php if (!$Page->FOType->Sortable || !$Page->sortUrl($Page->FOType)) { ?>
        <th class="<?= $Page->FOType->headerCellClass() ?>"><?= $Page->FOType->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->FOType->headerCellClass() ?>"><div role="button" data-table="farmer_organisation" data-sort="<?= HtmlEncode($Page->FOType->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->FOType->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->FOType->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->FOType->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->PhysicalAddress->Visible) { // PhysicalAddress ?>
    <?php if (!$Page->PhysicalAddress->Sortable || !$Page->sortUrl($Page->PhysicalAddress)) { ?>
        <th class="<?= $Page->PhysicalAddress->headerCellClass() ?>"><?= $Page->PhysicalAddress->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->PhysicalAddress->headerCellClass() ?>"><div role="button" data-table="farmer_organisation" data-sort="<?= HtmlEncode($Page->PhysicalAddress->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->PhysicalAddress->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->PhysicalAddress->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->PhysicalAddress->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->PostalAddress->Visible) { // PostalAddress ?>
    <?php if (!$Page->PostalAddress->Sortable || !$Page->sortUrl($Page->PostalAddress)) { ?>
        <th class="<?= $Page->PostalAddress->headerCellClass() ?>"><?= $Page->PostalAddress->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->PostalAddress->headerCellClass() ?>"><div role="button" data-table="farmer_organisation" data-sort="<?= HtmlEncode($Page->PostalAddress->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->PostalAddress->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->PostalAddress->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->PostalAddress->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->Phone->Visible) { // Phone ?>
    <?php if (!$Page->Phone->Sortable || !$Page->sortUrl($Page->Phone)) { ?>
        <th class="<?= $Page->Phone->headerCellClass() ?>"><?= $Page->Phone->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->Phone->headerCellClass() ?>"><div role="button" data-table="farmer_organisation" data-sort="<?= HtmlEncode($Page->Phone->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->Phone->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->Phone->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->Phone->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->_Email->Visible) { // Email ?>
    <?php if (!$Page->_Email->Sortable || !$Page->sortUrl($Page->_Email)) { ?>
        <th class="<?= $Page->_Email->headerCellClass() ?>"><?= $Page->_Email->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->_Email->headerCellClass() ?>"><div role="button" data-table="farmer_organisation" data-sort="<?= HtmlEncode($Page->_Email->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->_Email->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->_Email->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->_Email->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->ID->Visible) { // ID ?>
    <?php if (!$Page->ID->Sortable || !$Page->sortUrl($Page->ID)) { ?>
        <th class="<?= $Page->ID->headerCellClass() ?>"><?= $Page->ID->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->ID->headerCellClass() ?>"><div role="button" data-table="farmer_organisation" data-sort="<?= HtmlEncode($Page->ID->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->ID->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->ID->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->ID->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php
// Render list options (header, right)
$Page->ListOptions->render("header", "right");
?>
        </tr>
    </thead>
    <tbody><!-- Table body -->
<?php
$Page->RecordCount = 0;
$Page->RowCount = 0;
while ($Page->fetch()) {
    // Init row class and style
    $Page->RecordCount++;
    $Page->RowCount++;
    $Page->CssStyle = "";
    $Page->loadListRowValues($Page->CurrentRow);

    // Render row
    $Page->RowType = RowType::PREVIEW; // Preview record
    $Page->resetAttributes();
    $Page->renderListRow();

    // Set up row attributes
    $Page->RowAttrs->merge([
        "data-rowindex" => $Page->RowCount,
        "class" => ($Page->RowCount % 2 != 1) ? "ew-table-alt-row" : "",

        // Add row attributes for expandable row
        "data-widget" => "expandable-table",
        "aria-expanded" => "false",
    ]);

    // Render list options
    $Page->renderListOptions();
?>
    <tr <?= $Page->rowAttributes() ?>>
<?php
// Render list options (body, left)
$Page->ListOptions->render("body", "left", $Page->RowCount);
?>
<?php if ($Page->ProvinceCode->Visible) { // ProvinceCode ?>
        <!-- ProvinceCode -->
        <td<?= $Page->ProvinceCode->cellAttributes() ?>>
<span<?= $Page->ProvinceCode->viewAttributes() ?>>
<?= $Page->ProvinceCode->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->DistrictCode->Visible) { // DistrictCode ?>
        <!-- DistrictCode -->
        <td<?= $Page->DistrictCode->cellAttributes() ?>>
<span<?= $Page->DistrictCode->viewAttributes() ?>>
<?= $Page->DistrictCode->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->OrgCode->Visible) { // OrgCode ?>
        <!-- OrgCode -->
        <td<?= $Page->OrgCode->cellAttributes() ?>>
<span<?= $Page->OrgCode->viewAttributes() ?>>
<?= $Page->OrgCode->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->FarmerOrganisation->Visible) { // FarmerOrganisation ?>
        <!-- FarmerOrganisation -->
        <td<?= $Page->FarmerOrganisation->cellAttributes() ?>>
<span<?= $Page->FarmerOrganisation->viewAttributes() ?>>
<?= $Page->FarmerOrganisation->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->FOType->Visible) { // FOType ?>
        <!-- FOType -->
        <td<?= $Page->FOType->cellAttributes() ?>>
<span<?= $Page->FOType->viewAttributes() ?>>
<?= $Page->FOType->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->PhysicalAddress->Visible) { // PhysicalAddress ?>
        <!-- PhysicalAddress -->
        <td<?= $Page->PhysicalAddress->cellAttributes() ?>>
<span<?= $Page->PhysicalAddress->viewAttributes() ?>>
<?= $Page->PhysicalAddress->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->PostalAddress->Visible) { // PostalAddress ?>
        <!-- PostalAddress -->
        <td<?= $Page->PostalAddress->cellAttributes() ?>>
<span<?= $Page->PostalAddress->viewAttributes() ?>>
<?= $Page->PostalAddress->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->Phone->Visible) { // Phone ?>
        <!-- Phone -->
        <td<?= $Page->Phone->cellAttributes() ?>>
<span<?= $Page->Phone->viewAttributes() ?>>
<?= $Page->Phone->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->_Email->Visible) { // Email ?>
        <!-- Email -->
        <td<?= $Page->_Email->cellAttributes() ?>>
<span<?= $Page->_Email->viewAttributes() ?>>
<?= $Page->_Email->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->ID->Visible) { // ID ?>
        <!-- ID -->
        <td<?= $Page->ID->cellAttributes() ?>>
<span<?= $Page->ID->viewAttributes() ?>>
<?= $Page->ID->getViewValue() ?></span>
</td>
<?php } ?>
<?php
// Render list options (body, right)
$Page->ListOptions->render("body", "right", $Page->RowCount);
?>
    </tr>
<?php
} // while
?>
    </tbody>
</table><!-- /.table -->
</div><!-- /.card-body -->
<div class="card-footer ew-grid-lower-panel ew-preview-lower-panel"><!-- .card-footer -->
<?= $Page->Pager->render() ?>
<?php if ($Page->OtherOptions->visible()) { ?>
<div class="ew-preview-other-options">
<?php
    foreach ($Page->OtherOptions as $option) {
        $option->render("body");
    }
?>
</div>
<?php } ?>
</div><!-- /.card-footer -->
</div><!-- /.card -->
<?php } else { // No record ?>
<div class="card border-0"><!-- .card -->
<div class="ew-detail-count"><?= $Language->phrase("NoRecord") ?></div>
<?php if ($Page->OtherOptions->visible()) { ?>
<div class="ew-preview-other-options">
<?php
    foreach ($Page->OtherOptions as $option) {
        $option->render("body");
    }
?>
</div>
<?php } ?>
</div><!-- /.card -->
<?php } ?>
<?php
foreach ($Page->DetailCounts as $detailTblVar => $detailCount) {
?>
<div class="ew-detail-count d-none" data-table="<?= $detailTblVar ?>" data-count="<?= $detailCount ?>"><?= FormatInteger($detailCount) ?></div>
<?php
}
?>
<?php
$Page->showPageFooter();
echo GetDebugMessage();
?>
<?php
$Page->Recordset?->free();
?>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
