<?php

namespace PHPMaker2024\cidp24;

// Page object
$FarmerPreview = &$Page;
?>
<script>
ew.deepAssign(ew.vars, { tables: { farmer: <?= JsonEncode($Page->toClientVar()) ?> } });
</script>
<script>
loadjs.ready("head", function () {
    // Write your table-specific client script here, no need to add script tags.
});
</script>
<?php $Page->showPageHeader(); ?>
<?php if ($Page->TotalRecords > 0) { ?>
<div class="card ew-grid <?= $Page->TableGridClass ?>"><!-- .card -->
<div class="card-header ew-grid-upper-panel ew-preview-upper-panel"><!-- .card-header -->
<?= $Page->Pager->render() ?>
<?php if ($Page->OtherOptions->visible()) { ?>
<div class="ew-preview-other-options">
<?php
    foreach ($Page->OtherOptions as $option) {
        $option->render("body");
    }
?>
</div>
<?php } ?>
</div><!-- /.card-header -->
<div class="card-body ew-preview-middle-panel ew-grid-middle-panel <?= $Page->TableContainerClass ?>" style="<?= $Page->TableContainerStyle ?>"><!-- .card-body -->
<table class="<?= $Page->TableClass ?>"><!-- .table -->
    <thead><!-- Table header -->
        <tr class="ew-table-header">
<?php
// Render list options
$Page->renderListOptions();

// Render list options (header, left)
$Page->ListOptions->render("header", "left");
?>
<?php if ($Page->ProvinceCode->Visible) { // ProvinceCode ?>
    <?php if (!$Page->ProvinceCode->Sortable || !$Page->sortUrl($Page->ProvinceCode)) { ?>
        <th class="<?= $Page->ProvinceCode->headerCellClass() ?>"><?= $Page->ProvinceCode->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->ProvinceCode->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->ProvinceCode->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->ProvinceCode->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->ProvinceCode->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->ProvinceCode->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->DistrictCode->Visible) { // DistrictCode ?>
    <?php if (!$Page->DistrictCode->Sortable || !$Page->sortUrl($Page->DistrictCode)) { ?>
        <th class="<?= $Page->DistrictCode->headerCellClass() ?>"><?= $Page->DistrictCode->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->DistrictCode->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->DistrictCode->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->DistrictCode->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->DistrictCode->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->DistrictCode->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->CampCode->Visible) { // CampCode ?>
    <?php if (!$Page->CampCode->Sortable || !$Page->sortUrl($Page->CampCode)) { ?>
        <th class="<?= $Page->CampCode->headerCellClass() ?>"><?= $Page->CampCode->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->CampCode->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->CampCode->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->CampCode->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->CampCode->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->CampCode->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->VillageCode->Visible) { // VillageCode ?>
    <?php if (!$Page->VillageCode->Sortable || !$Page->sortUrl($Page->VillageCode)) { ?>
        <th class="<?= $Page->VillageCode->headerCellClass() ?>"><?= $Page->VillageCode->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->VillageCode->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->VillageCode->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->VillageCode->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->VillageCode->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->VillageCode->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->FarmerNo->Visible) { // FarmerNo ?>
    <?php if (!$Page->FarmerNo->Sortable || !$Page->sortUrl($Page->FarmerNo)) { ?>
        <th class="<?= $Page->FarmerNo->headerCellClass() ?>"><?= $Page->FarmerNo->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->FarmerNo->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->FarmerNo->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->FarmerNo->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->FarmerNo->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->FarmerNo->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->NRC->Visible) { // NRC ?>
    <?php if (!$Page->NRC->Sortable || !$Page->sortUrl($Page->NRC)) { ?>
        <th class="<?= $Page->NRC->headerCellClass() ?>"><?= $Page->NRC->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->NRC->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->NRC->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->NRC->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->NRC->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->NRC->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->FarmerName->Visible) { // FarmerName ?>
    <?php if (!$Page->FarmerName->Sortable || !$Page->sortUrl($Page->FarmerName)) { ?>
        <th class="<?= $Page->FarmerName->headerCellClass() ?>"><?= $Page->FarmerName->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->FarmerName->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->FarmerName->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->FarmerName->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->FarmerName->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->FarmerName->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->FarmerType->Visible) { // FarmerType ?>
    <?php if (!$Page->FarmerType->Sortable || !$Page->sortUrl($Page->FarmerType)) { ?>
        <th class="<?= $Page->FarmerType->headerCellClass() ?>"><?= $Page->FarmerType->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->FarmerType->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->FarmerType->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->FarmerType->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->FarmerType->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->FarmerType->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->DOB->Visible) { // DOB ?>
    <?php if (!$Page->DOB->Sortable || !$Page->sortUrl($Page->DOB)) { ?>
        <th class="<?= $Page->DOB->headerCellClass() ?>"><?= $Page->DOB->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->DOB->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->DOB->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->DOB->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->DOB->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->DOB->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->Age->Visible) { // Age ?>
    <?php if (!$Page->Age->Sortable || !$Page->sortUrl($Page->Age)) { ?>
        <th class="<?= $Page->Age->headerCellClass() ?>"><?= $Page->Age->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->Age->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->Age->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->Age->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->Age->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->Age->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->Gender->Visible) { // Gender ?>
    <?php if (!$Page->Gender->Sortable || !$Page->sortUrl($Page->Gender)) { ?>
        <th class="<?= $Page->Gender->headerCellClass() ?>"><?= $Page->Gender->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->Gender->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->Gender->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->Gender->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->Gender->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->Gender->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->MaritalStatus->Visible) { // MaritalStatus ?>
    <?php if (!$Page->MaritalStatus->Sortable || !$Page->sortUrl($Page->MaritalStatus)) { ?>
        <th class="<?= $Page->MaritalStatus->headerCellClass() ?>"><?= $Page->MaritalStatus->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->MaritalStatus->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->MaritalStatus->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->MaritalStatus->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->MaritalStatus->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->MaritalStatus->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->PhoneNo->Visible) { // PhoneNo ?>
    <?php if (!$Page->PhoneNo->Sortable || !$Page->sortUrl($Page->PhoneNo)) { ?>
        <th class="<?= $Page->PhoneNo->headerCellClass() ?>"><?= $Page->PhoneNo->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->PhoneNo->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->PhoneNo->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->PhoneNo->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->PhoneNo->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->PhoneNo->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->_Email->Visible) { // Email ?>
    <?php if (!$Page->_Email->Sortable || !$Page->sortUrl($Page->_Email)) { ?>
        <th class="<?= $Page->_Email->headerCellClass() ?>"><?= $Page->_Email->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->_Email->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->_Email->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->_Email->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->_Email->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->_Email->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->FarmerOrg->Visible) { // FarmerOrg ?>
    <?php if (!$Page->FarmerOrg->Sortable || !$Page->sortUrl($Page->FarmerOrg)) { ?>
        <th class="<?= $Page->FarmerOrg->headerCellClass() ?>"><?= $Page->FarmerOrg->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->FarmerOrg->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->FarmerOrg->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->FarmerOrg->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->FarmerOrg->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->FarmerOrg->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->FarmerOrgPosition->Visible) { // FarmerOrgPosition ?>
    <?php if (!$Page->FarmerOrgPosition->Sortable || !$Page->sortUrl($Page->FarmerOrgPosition)) { ?>
        <th class="<?= $Page->FarmerOrgPosition->headerCellClass() ?>"><?= $Page->FarmerOrgPosition->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->FarmerOrgPosition->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->FarmerOrgPosition->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->FarmerOrgPosition->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->FarmerOrgPosition->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->FarmerOrgPosition->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php if ($Page->AgeGroup->Visible) { // AgeGroup ?>
    <?php if (!$Page->AgeGroup->Sortable || !$Page->sortUrl($Page->AgeGroup)) { ?>
        <th class="<?= $Page->AgeGroup->headerCellClass() ?>"><?= $Page->AgeGroup->caption() ?></th>
    <?php } else { ?>
        <th class="<?= $Page->AgeGroup->headerCellClass() ?>"><div role="button" data-table="farmer" data-sort="<?= HtmlEncode($Page->AgeGroup->Name) ?>" data-sort-type="1" data-sort-order="<?= $Page->AgeGroup->getNextSort() ?>">
            <div class="ew-table-header-btn">
                <span class="ew-table-header-caption"><?= $Page->AgeGroup->caption() ?></span>
                <span class="ew-table-header-sort"><?= $Page->AgeGroup->getSortIcon() ?></span>
            </div>
        </th>
    <?php } ?>
<?php } ?>
<?php
// Render list options (header, right)
$Page->ListOptions->render("header", "right");
?>
        </tr>
    </thead>
    <tbody><!-- Table body -->
<?php
$Page->RecordCount = 0;
$Page->RowCount = 0;
while ($Page->fetch()) {
    // Init row class and style
    $Page->RecordCount++;
    $Page->RowCount++;
    $Page->CssStyle = "";
    $Page->loadListRowValues($Page->CurrentRow);

    // Render row
    $Page->RowType = RowType::PREVIEW; // Preview record
    $Page->resetAttributes();
    $Page->renderListRow();

    // Set up row attributes
    $Page->RowAttrs->merge([
        "data-rowindex" => $Page->RowCount,
        "class" => ($Page->RowCount % 2 != 1) ? "ew-table-alt-row" : "",

        // Add row attributes for expandable row
        "data-widget" => "expandable-table",
        "aria-expanded" => "false",
    ]);

    // Render list options
    $Page->renderListOptions();
?>
    <tr <?= $Page->rowAttributes() ?>>
<?php
// Render list options (body, left)
$Page->ListOptions->render("body", "left", $Page->RowCount);
?>
<?php if ($Page->ProvinceCode->Visible) { // ProvinceCode ?>
        <!-- ProvinceCode -->
        <td<?= $Page->ProvinceCode->cellAttributes() ?>>
<span<?= $Page->ProvinceCode->viewAttributes() ?>>
<?= $Page->ProvinceCode->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->DistrictCode->Visible) { // DistrictCode ?>
        <!-- DistrictCode -->
        <td<?= $Page->DistrictCode->cellAttributes() ?>>
<span<?= $Page->DistrictCode->viewAttributes() ?>>
<?= $Page->DistrictCode->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->CampCode->Visible) { // CampCode ?>
        <!-- CampCode -->
        <td<?= $Page->CampCode->cellAttributes() ?>>
<span<?= $Page->CampCode->viewAttributes() ?>>
<?= $Page->CampCode->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->VillageCode->Visible) { // VillageCode ?>
        <!-- VillageCode -->
        <td<?= $Page->VillageCode->cellAttributes() ?>>
<span<?= $Page->VillageCode->viewAttributes() ?>>
<?= $Page->VillageCode->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->FarmerNo->Visible) { // FarmerNo ?>
        <!-- FarmerNo -->
        <td<?= $Page->FarmerNo->cellAttributes() ?>>
<span<?= $Page->FarmerNo->viewAttributes() ?>>
<?= $Page->FarmerNo->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->NRC->Visible) { // NRC ?>
        <!-- NRC -->
        <td<?= $Page->NRC->cellAttributes() ?>>
<span<?= $Page->NRC->viewAttributes() ?>>
<?= $Page->NRC->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->FarmerName->Visible) { // FarmerName ?>
        <!-- FarmerName -->
        <td<?= $Page->FarmerName->cellAttributes() ?>>
<span<?= $Page->FarmerName->viewAttributes() ?>>
<?= $Page->FarmerName->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->FarmerType->Visible) { // FarmerType ?>
        <!-- FarmerType -->
        <td<?= $Page->FarmerType->cellAttributes() ?>>
<span<?= $Page->FarmerType->viewAttributes() ?>>
<?= $Page->FarmerType->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->DOB->Visible) { // DOB ?>
        <!-- DOB -->
        <td<?= $Page->DOB->cellAttributes() ?>>
<span<?= $Page->DOB->viewAttributes() ?>>
<?= $Page->DOB->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->Age->Visible) { // Age ?>
        <!-- Age -->
        <td<?= $Page->Age->cellAttributes() ?>>
<span<?= $Page->Age->viewAttributes() ?>>
<?= $Page->Age->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->Gender->Visible) { // Gender ?>
        <!-- Gender -->
        <td<?= $Page->Gender->cellAttributes() ?>>
<span<?= $Page->Gender->viewAttributes() ?>>
<?= $Page->Gender->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->MaritalStatus->Visible) { // MaritalStatus ?>
        <!-- MaritalStatus -->
        <td<?= $Page->MaritalStatus->cellAttributes() ?>>
<span<?= $Page->MaritalStatus->viewAttributes() ?>>
<?= $Page->MaritalStatus->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->PhoneNo->Visible) { // PhoneNo ?>
        <!-- PhoneNo -->
        <td<?= $Page->PhoneNo->cellAttributes() ?>>
<span<?= $Page->PhoneNo->viewAttributes() ?>>
<?= $Page->PhoneNo->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->_Email->Visible) { // Email ?>
        <!-- Email -->
        <td<?= $Page->_Email->cellAttributes() ?>>
<span<?= $Page->_Email->viewAttributes() ?>>
<?= $Page->_Email->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->FarmerOrg->Visible) { // FarmerOrg ?>
        <!-- FarmerOrg -->
        <td<?= $Page->FarmerOrg->cellAttributes() ?>>
<span<?= $Page->FarmerOrg->viewAttributes() ?>>
<?= $Page->FarmerOrg->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->FarmerOrgPosition->Visible) { // FarmerOrgPosition ?>
        <!-- FarmerOrgPosition -->
        <td<?= $Page->FarmerOrgPosition->cellAttributes() ?>>
<span<?= $Page->FarmerOrgPosition->viewAttributes() ?>>
<?= $Page->FarmerOrgPosition->getViewValue() ?></span>
</td>
<?php } ?>
<?php if ($Page->AgeGroup->Visible) { // AgeGroup ?>
        <!-- AgeGroup -->
        <td<?= $Page->AgeGroup->cellAttributes() ?>>
<span<?= $Page->AgeGroup->viewAttributes() ?>>
<?= $Page->AgeGroup->getViewValue() ?></span>
</td>
<?php } ?>
<?php
// Render list options (body, right)
$Page->ListOptions->render("body", "right", $Page->RowCount);
?>
    </tr>
<?php
} // while
?>
    </tbody>
</table><!-- /.table -->
</div><!-- /.card-body -->
<div class="card-footer ew-grid-lower-panel ew-preview-lower-panel"><!-- .card-footer -->
<?= $Page->Pager->render() ?>
<?php if ($Page->OtherOptions->visible()) { ?>
<div class="ew-preview-other-options">
<?php
    foreach ($Page->OtherOptions as $option) {
        $option->render("body");
    }
?>
</div>
<?php } ?>
</div><!-- /.card-footer -->
</div><!-- /.card -->
<?php } else { // No record ?>
<div class="card border-0"><!-- .card -->
<div class="ew-detail-count"><?= $Language->phrase("NoRecord") ?></div>
<?php if ($Page->OtherOptions->visible()) { ?>
<div class="ew-preview-other-options">
<?php
    foreach ($Page->OtherOptions as $option) {
        $option->render("body");
    }
?>
</div>
<?php } ?>
</div><!-- /.card -->
<?php } ?>
<?php
foreach ($Page->DetailCounts as $detailTblVar => $detailCount) {
?>
<div class="ew-detail-count d-none" data-table="<?= $detailTblVar ?>" data-count="<?= $detailCount ?>"><?= FormatInteger($detailCount) ?></div>
<?php
}
?>
<?php
$Page->showPageFooter();
echo GetDebugMessage();
?>
<?php
$Page->Recordset?->free();
?>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
